; an MSX music player
;
; a6 is next
;
;
; I/O map
;
; $90 printer strobe write, status read
; $91 printer data R/W
; $92
; $93 printer bus direction - write a 3 to set output mode (and /PRST)
;                                     2 to set input mode (and /PRST)
;                                     1 clears /PRST
;
; $98 VDP
; $99 VDP
; $9A VDP
; $9B VDP
; $9C VDP
; $9D VDP
; $9E VDP
; $9F VDP
;
; $A0 PSG address latch
; $A1 PSG data write
; $A2 PSG data read
;       00-1 channel A frequency (12 bits)
;       02-3 channel B freq             (f = 111862Hz / period)
;       04-5 channel C freq
;       06   noise freq (5 bits)
;       07   port&mixer config  bit 0-2 tone A, B, C enable (active low)
;                               bit 3-5 noise A, B, C enable (active low)
;                               bit 6   always set to 0
;                               bit 7   always set to 1
;       08   channel A volume   bit 0-3 = level
;       09   channel B volume   bit 4 - 0=fixed, 1=envelope generator
;       0A   channel C volume
;       0B-C envelope frequency (16 bits)  (f = 6991Hz / period)
;       0D   envelope control
;       0E   input port data    bit 0 - up
;                               bit 1 - down
;                               bit 2 - left
;                               bit 3 - right
;                               bit 4 - TRGA
;                               bit 5 - TRGB
;                               bit 6 - JIS/50
;                               bit 7 - CM1
;       0F   output port data
;                               bit 0 - TRGA1
;                               bit 1 - TRGB1
;                               bit 2 - TRGA2
;                               bit 3 - TRGB2
;                               bit 4 - STB1
;                               bit 5 - STB2
;                               bit 6 - port select for input bits 0-5
;                               bit 7 - /KANA
;
; $A8 slot config register (bits 0&1 control $0000-$3FFF)
; $A9 keyboard signal read
; $AA bits 0-3 kb drive, 4=REM, 5=cassette write, 6=/CAPS, 7=PPISND
; $AB mode control
;
; 

        org $A000-7

        ; header
        db $FE
        dw $A000
        dw theend-1
        dw $A000

        ld hl,greatj+5
        ld (mptr),hl    ; address of music

a250
        ; beginning of loop

        ld d,3          ; number of channels to process
        ld ix,volume
a315                         ; big loop for emulating envelope
        ld a,(ix+30)    ; status
        and a
        jp nz,a316
        ld a,(ix+25)    ; release
        call subvol     ; KEY OFF
        jp a317
a316
        cp 1            ; KEY ON
        jp nz,a320
        ld a,(ix+5)     ; attack
        srl a
        jp nc,a831
        ld b,a
        ld a,(ix+45)    ; avolume low byte
        adc a,127
        ld (ix+45),a    ; avolume low byte
        ld a,b
a831
        adc a,(ix+40)   ; avolume high byte
        ld (ix+40),a
        cp (ix)         ; volume
        jp c,a317
        ld a,(ix)       ; volume
        ld (ix+40),a    ; avolume high byte
        inc (ix+30)     ; status
        jp a317
a320
        cp 2            ; DECAY 1
        jp nz,a321
        ld a,(ix+10)    ; decay1        
        call subvol
        ld b,0
        ld a,(ix+20)    ; T1L
        ld hl,0
        and a
        jp z,a836
        ld c,(ix)       ; volume
a834
        add hl,bc
        dec a
        jp nz,a834
        srl h
        rr l
        srl h
        rr l
        srl l
        srl l
        srl l
a836
        ld a,l
        cp (ix+40)      ; avolume high byte
        jp c,a317
        inc (ix+30)     ; status
        jp a317
a321
        ld a,(ix+45)    ; avolume low byte
        sub (ix+15)     ; DECAY2
        ld (ix+45),a
        jp nc,a317
        dec (ix+40)     ; avolume high byte
a317
        ; check that volume hasn't underflowificated
        ld a,(ix+40)
        and a
        jp p,a319
        ld a,0
        ld (ix+40),a    ; avolume high byte
a319
        inc ix
        dec d
        jp nz,a315

a4

        ; store volumes
        ld bc,$08A0
        ld a,(avolume)
        srl a
        out (c),b
        out ($A1),a
        ld a,(avolume+1)
        srl a
        inc b
        out (c),b
        out ($A1),a
        ld a,(avolume+2)
        srl a
        inc b
        out (c),b
        out ($A1),a


; parse some song data (...or not)

        ld hl,(mptr)
        ld a,(countd)
        and a
        jp z,a307
        dec a
        ld (countd),a
        jp a314
a307
        ld a,(hl)
        inc hl
        ld c,a
        cp 255
        jp nz,a326
        ld c,(hl)
        inc hl
        ld b,(hl)
        push bc
        pop hl                ; jump
        jp a307
a326
        and 224
        jp nz,a310
        ld b,0
        ld a,(hl)
        inc hl          
        ld ix,volume
        add ix,bc
        ld (ix),a               ; set a register
        jp a307
a310
        cp 32
        jp nz,a312
        ld a,31
        and c
        ld (countd),a           ; wait some frames
        jp a314
a312
        cp 128
        jp nz,a313
        ld a,28
        and c
        srl a
        srl a
        ld e,a
        ld d,0
        ld ix,freqs             ; set frequency
        add ix,de
        ld a,3
        and c
        ld (ix),a
        ld a,(hl)
        inc hl
        ld (ix+5),a
        jp a307
a313
        cp 64
        jp nz,a308
        ld a,14
        and c
        ld ix,state
        srl a
        ld e,a
        ld d,0
        add ix,de
        ld a,1
        and c
        ld (ix),a               ; key on/off
        jp a307
a308
        cp 96
        jp nz,a395
        ld a,7
        and c
        ld e,a
        ld d,0
        ld ix,vibjunk
        add ix,de
        ld a,16
        and c
        ld (ix),a               ; vibrato on/off
        jp a307
a395
        cp 160
        jp nz,a837
        inc hl                  ; panning (not needed)
a837
        jp a307
a314
        ld (mptr),hl


        ld ix,vibjunk
        ld iy,freqs
        ld d,3          ; number of channels (again)
a396
        ld a,(ix)
        and a
        jp z,a397
	inc a
        cp 26
        jp nz,a398
        ld a,16
a398
        ld (ix),a
        ld b,a
        ld a,(iy)
        and a
        jp nz,a399
        ld a,(iy+5)
        cp 140
        jp nc,a399
        ld a,10
        add a,b
a399
        ld hl,vibpat-16
        ld c,a
        ld b,0
        add hl,bc
        ld a,(hl)
        ld c,a
        cp 255
        jp z,a880
        ld c,0
a880
        add a,(iy+5)
        ld (iy+5),a
        ld a,(iy)
        adc a,c
        ld (iy),a
a397
        inc ix
        inc iy
        dec d
        jp nz,a396

        ld bc,$00A0
        out (c),b
        ld a,(freqs+5)
        out ($A1),a
        inc b
        out (c),b
        ld a,(freqs)
        out ($A1),a
        inc b
        out (c),b
        ld a,(freqs+6)
        out ($A1),a
        inc b
        out (c),b
        ld a,(freqs+1)
        out ($A1),a
        inc b
        out (c),b
        ld a,(freqs+7)
        out ($A1),a
        inc b
        out (c),b
        ld a,(freqs+2)
        out ($A1),a


        call waitv


;        ld bc,$0FA0
;        out (c),b
;        in a,($A2)              ; toggle kana LED
;        xor 128
;        out (c),b
;        out ($A1),a

        ld hl,(timer)
        inc hl
        ld (timer),hl

        ld a,h
        cp 20
        jp nz,a6
        ret
a6

        jp a250

subvol
        ld b,0
        sla a
        rl b
        sla a
        rl b
        ld c,a
        ld a,(ix+45)            ; avolume low byte
        sub c
        ld (ix+45),a
        ld a,(ix+40)            ; avolume high byte
        sbc a,b
        ld (ix+40),a
        ret

waitv
        ld a,0
        ld ($F3E7),a
a3
        ld a,($F3E7)
        cp 0
        jp z,a3
        ret

; music player work RAM

        ;$20B0-1 pointer for music
mptr    dw 0 
        ;$20B2   countdown until registers change
countd  db 0
timer   dw 0 

        ;$26C8-C  volume
volume  db 0,0,0,0,0
        ;$26CD-D1 attack
attack  db 0,0,0,0,0
        ;$26D2-D6 decay1
decay1  db 0,0,0,0,0
        ;$26D7-DB decay2
decay2  db 0,0,0,0,0
        ;$26DC-E0 T1L
T1L     db 0,0,0,0,0
        ;$26E1-E5 release
release db 0,0,0,0,0
        ;$26E6-EA state
state   db 0,0,0,0,0
        ;$20BB-F vibrato (music player junk)
vibjunk db 0,0,0,0,0
        ;$26EB-F  active volume high byte
avolume db 9,9,9,0,0
        ;$26F0-4  active volume low byte
        db 0,0,0,0,0
        ;$2540-9  frequencies (high bytes first)
freqs   db 0,0,0,0,0,0,0,0,0,0

vibpat
        db 1,1,0,255,255,255,255,0,1,1
        db 0,1,0,0,255,0,255,0,0,1

greatj
        incbin "justice.dt"
        db 255
        dw mota+5
mota
        incbin "mota3.dt"
        db 255
        dw greatj+5

theend
